/*  
 * Copyright 2005 unitarou <boss@unitarou.org>. 
 * All rights reserved.
 * 
 * This program and the accompanying materials are made available under the terms of 
 * the Common Public License v1.0 which accompanies this distribution, 
 * and is available at http://opensource.org/licenses/cpl.php
 * 
 * Contributors:
 *     unitarou - initial API and implementation
 */
package org.unitarou.yukinoshita.view.cmd;

import org.unitarou.util.ArgumentChecker;
import org.unitarou.yukinoshita.view.HandlerPhase;

/**
 * Rg[̏Ԃł{@link org.unitarou.yukinoshita.view.HandlerPhase}
 * ԂςƂʒmR}hłB
 * 
 * @author unitarou &lt;boss@unitarou.org&gt; 
 */
public class ChangeHandlerPhaseCommand extends AbstractCommand4View {

	private final HandlerPhase newPhase_;
	/**
	 * @throws org.unitarou.lang.NullArgumentException <code>null</code>̏ꍇ
	 */
	public ChangeHandlerPhaseCommand(HandlerPhase handlerPhase) {
		super();
		ArgumentChecker.throwIfNull(handlerPhase);
		newPhase_ = handlerPhase;
	}

	/* (non-Javadoc)
	 * @see org.unitarou.yukinoshita.view.cmd.Command4View#execute()
	 */
	public void execute() {
		throwIfNotSetup();
		Parameter parameter = getParameter();
        if (!HandlerPhase.SETUP.equals(parameter.getCurrentStatus())) {
            fireHandlerPhaseChange(newPhase_);
           	parameter.setCurrentStatus(newPhase_);
            return;
        }

        fireHandlerPhaseChange(newPhase_);
        parameter.setCurrentStatus(newPhase_);
	}
}
