/*  
 * Copyright 2005 unitarou <boss@unitarou.org>. 
 * All rights reserved.
 * 
 * This program and the accompanying materials are made available under the terms of 
 * the Common Public License v1.0 which accompanies this distribution, 
 * and is available at http://opensource.org/licenses/cpl.php
 * 
 * Contributors:
 *     unitarou - initial API and implementation
 */
package org.unitarou.yukinoshita.view.provider.blklp;

import java.util.Set;

import org.unitarou.lang.Strings;
import org.unitarou.ml.MessageResource;
import org.unitarou.sgf.type.SgfPoint;
import org.unitarou.sgf.util.Stone;
import org.unitarou.util.ArgumentChecker;
import org.unitarou.yukinoshita.model.NodeView;
import org.unitarou.yukinoshita.view.jface.board.BlockPainter;

/**
 * ԍ\郉xvoC_[łB
 * 
 * @author unitarou &lt;boss@unitarou.org&gt;
 */
public class MoveNumberProvider implements BlockLabelProvider {
    /** uԍv*/
    static private final MessageResource LB_DISPLAY_NAME
    		= new MessageResource(MoveNumberProvider.class, "lbDisplayName"); //$NON-NLS-1$
    		

    /**
     * 
     */
    public MoveNumberProvider() {
        super();
    }

    /* (non-Javadoc)
     * @see org.unitarou.yukinoshita.view.jface.board.blp.BlockLabelProvider#getDisplayName()
     */
    public String displayName() {
        return LB_DISPLAY_NAME.get();
    }

    /* (non-Javadoc)
     * @see org.unitarou.yukinoshita.view.jface.board.blp.BlockLabelProvider#getLabel(org.unitarou.yukinoshita.model.NodeView, org.unitarou.sgf.type.SgfPoint)
     */
    public String getLabel(NodeView nodeView, SgfPoint point) {
        ArgumentChecker.throwIfNull(nodeView, point);

        Integer moveNumber = getMoveNumber(nodeView.getIgoBoard().getStone(point));
        return (moveNumber == null) ? Strings.EMPTY : moveNumber.toString();
    }
    
    /**
     * stone̒ԍԂ܂B<br>
     * nullAԍ݂Ȃꍇ<code>null</code>Ԃ܂B
     * @param stone
     * @return
     */
    private Integer getMoveNumber(Stone stone) {
        return (stone != null) ? stone.getNumber() : null;
    }

	/* (non-Javadoc)
	 * @see org.unitarou.yukinoshita.view.jface.board.BlockPainter#getDurablePaintings(org.unitarou.yukinoshita.model.NodeView)
	 */
	public Set<SgfPoint> getDurablePaintings(NodeView now) {
		// TODO 蔲(΂̂ꏊɒuׂAvZRXĝ)
		return BlockPainter.EMPTY_SET;
	}

	/* (non-Javadoc)
	 * @see org.unitarou.yukinoshita.view.jface.board.BlockPainter#getTransientPaintings(org.unitarou.yukinoshita.model.NodeView)
	 */
	public Set<SgfPoint> getTransientPaintings(NodeView nodeView) {
		return BlockPainter.EMPTY_SET;
	}
}
